﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace MyBookshelf.Model
{
    // Requires the following directives:
    // using System.ComponentModel;
    // using System.Runtime.CompilerServices;
    public abstract class TableBase : INotifyPropertyChanged
    {
        private string id;
        public string Id
        {
            get
            {
                return id;
            }

            set
            {
                id = value; OnPropertyChanged();
            }
        }

        private DateTimeOffset createdAt;
        public DateTimeOffset CreatedAt
        {
            get
            {
                return createdAt;
            }

            set
            {
                createdAt = value; OnPropertyChanged();
            }
        }

        private DateTimeOffset updatedAt;
        public DateTimeOffset UpdatedAt
        {
            get
            {
                return updatedAt;
            }

            set
            {
                updatedAt = value; OnPropertyChanged();
            }
        }

        private string version;
        public string Version
        {
            get
            {
                return version;
            }

            set
            {
                version = value; OnPropertyChanged();
            }
        }

        private string userId;
        public string UserId
        {
            get
            {
                return userId;
            }

            set
            {
                userId = value; OnPropertyChanged();
            }
        }

        private bool deleted;
        public bool Deleted
        {
            get
            {
                return deleted;
            }

            set
            {
                deleted = value; OnPropertyChanged();
            }
        }

        public TableBase()
        {
            this.CreatedAt = DateTimeOffset.Now;
            this.UpdatedAt = DateTimeOffset.Now;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
